#include <iostream>
#include <vector>
#include "histogram.h"
#include "text.h"
#include "svg.h"
#include <curl/curl.h>

using namespace std;

struct Input {
    vector<double> numbers;
    size_t bin_count{};
};

Input input_data(istream& in, bool prompt) {
    if (prompt) {
        cerr << "Enter number count, numbers and bin count: ";
    }

    size_t number_count;
    in >> number_count;

    Input input;
    input.numbers.resize(number_count);

    for (size_t i = 0; i < number_count; i++) {
        in >> input.numbers[i];
    }

    in >> input.bin_count;

    return input;
}

int main(int argc, char* argv[]) {
    if (argc > 1) {
        cout << "argc = " << argc << endl;
        for (int i = 0; i < argc; ++i) {
            cout << "argv[" << i << "] = " << argv[i] << endl;
        }
        return 0;
    }

    curl_global_init(CURL_GLOBAL_ALL);
    auto in = input_data(cin, true);
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_svg(bins);

    return 0;
}
